; 
 
.486                             ; set processor model
.model flat, stdcall         ; default STDCALL calling convention
option casemap :none    ; always use the case sensitive option 
 
include \masm32\include\windows.inc
include \masm32\include\system.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc
include \masm32\include\masm32.inc
include \masm32\owm\include\cobject.inc

include \masm32\macros\macros.asm
include \masm32\owm\macros\system.mac
   
       
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\owm\lib\cobject.lib
      
; ----------------------------------------------
; prototypes for local procedures go here
; ----------------------------------------------
 WinMain proto  hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 

IDM_OPEN      EQU  10002
IDM_EXIT       EQU  10003

CLSIID   CLSID_MyCom,     {A21A8C42-1266-11D4-A3240040F6D487D9}

Interface  IMyCom,            {A21A8C41-1266-11D4-A3240040F6D487D9}
    QueryInterface       PTRPROTO@12   ?      	
    AddRef                  PTRPROTO@4     ?  	
    Release                 PTRPROTO@4     ?
    GetValue                PTRPROTO@8     ?
    SetValue                PTRPROTO@8     ?
EndI
    
.data
  COINIT IMyCom  
  ClassName   db "WinMasm32App",0
  AppName     db "Project",0
  MenuName   db "IDR_MENU",0
  ErrMessage  db "  COM !",0
  szStr           db "  COM  (%i)",0
                              
.data?
  hInstance           HINSTANCE   ?
  CommandLine     LPSTR          ?
  szErr                  db               MAX_PATH DUP ( ?)
      
.code

start: 

     invoke GetModuleHandle, NULL
     mov    hInstance,eax
     invoke GetCommandLine
     mov CommandLine,eax
     invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWNORMAL
     invoke ExitProcess,eax
      
; 
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 

     mov   wc.cbSize,SIZEOF WNDCLASSEX
     mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
     mov   wc.lpfnWndProc, OFFSET WndProc
     mov   wc.cbClsExtra,NULL
     mov   wc.cbWndExtra,NULL
     mem  wc.hInstance, hInst
     mov   wc.hbrBackground,COLOR_WINDOW+1
     mov   wc.lpszMenuName, OFFSET MenuName        
     mov   wc.lpszClassName, OFFSET ClassName
     invoke LoadIcon,NULL,IDI_APPLICATION
     mov   wc.hIcon,eax
     mov   wc.hIconSm,eax
     invoke LoadCursor,NULL,IDC_ARROW
     mov   wc.hCursor,eax

     invoke RegisterClassEx, addr wc
     invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
                                 WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
                                 CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
                                 hInst,NULL
     mov   hwnd,eax
     invoke ShowWindow, hwnd,CmdShow
     invoke UpdateWindow, hwnd

     .while TRUE

         invoke GetMessage, ADDR msg,NULL,0,0
         .break .if (!eax)
         ;invoke TranslateMessage, ADDR msg        ; no comment Virtual key
         invoke DispatchMessage, ADDR msg

     .endw

     mov     eax,msg.wParam
     ret

WinMain endp

; 
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
LOCAL pv:DWORD
LOCAL vr:DWORD
LOCAL Buffer[MAX_PATH]:BYTE

     .if uMsg==WM_DESTROY
         invoke PostQuitMessage,NULL
     .elseif uMsg==WM_COMMAND
         mov eax,wParam
         .if ax==IDM_OPEN
            invoke CoInitialize,NULL
            CoCreateObject  CLSID_MyCom,IMyCom,CLSCTX_INPROC_SERVER
            .if eax!=NULL
                mov pv, eax
                invokemtd pv.IMyCom.SetValue,257
                invokemtd pv.IMyCom.GetValue, ADDR vr
                invoke wsprintf,ADDR Buffer, ADDR szStr,vr
                invoke MessageBox, NULL, ADDR Buffer,NULL, MB_OK or MB_ICONINFORMATION
            .else
                invoke MessageBox, NULL, ADDR ErrMessage,NULL, MB_OK or MB_ICONERROR or MB_TASKMODAL
            .endif
            invoke CoUninitialize
         .elseif ax==IDM_EXIT
            invoke DestroyWindow,hWnd
         .endif          

     .else
         invoke DefWindowProc,hWnd,uMsg,wParam,lParam
         ret
     .endif

     xor    eax,eax
     ret

WndProc endp

;  
 
 
end start
